// UseunitLink.cpp : implementation file
//

#include "stdafx.h"
#include "vg.h"
#include "group.h"
#include "sheet.h"
#include "unit.h"
#include "VC.h"
#include "UseunitLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// UseunitLink dialog


UseunitLink::UseunitLink(CWnd* pParent /*=NULL*/)
  : CDialog(UseunitLink::IDD, pParent)
{
  //{{AFX_DATA_INIT(UseunitLink)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
}


void UseunitLink::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(UseunitLink)
  DDX_Control(pDX, IDC_VGCTRL1, vg1);
  //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(UseunitLink, CDialog)
  //{{AFX_MSG_MAP(UseunitLink)
  ON_WM_SIZE()
  ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
  ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// UseunitLink message handlers

BOOL UseunitLink::OnInitDialog() 
{
  CDialog::OnInitDialog();
  
  vg1.Design("http://www.visual-graph.com/activex/link.xml");
  return TRUE;
}

void UseunitLink::OnSize(UINT nType, int cx, int cy) 
{
  CDialog::OnSize(nType, cx, cy);
  
  if( vg1.m_hWnd )
  {
    vg1.MoveWindow( 0, 0, cx, cy - 60 );
    CWnd* bt = GetDlgItem( IDC_BUTTON1 );
    bt->MoveWindow( 0, cy - 50, 150, 20 );
    bt = GetDlgItem( IDC_BUTTON2 );
    bt->MoveWindow( 150, cy - 50, 150, 20 );
  }
};

void UseunitLink::OnButton1() 
{
  Cvg vg = vg1.GetVg();
  CSheet sheet = vg.GetActiveSheet();
  CUnit d1 = sheet.UnitByName("HKnife1");
  CUnit d2 = sheet.UnitByName("TransformerB1");
  CUnit d3 = sheet.UnitByName("HSwitch1");
  CUnit Line1 = sheet.UnitByName("Line1");

  CUnit line = sheet.AddUnit(NULL, "line");
  line.Execute("PointCount = 3; LinkMode = 1; Bytes[1] = 8; Bytes[2] = 8");
  sheet.SetLink(d1, line, "L2", "P0");
  sheet.SetLink(line, d2, "P1", "L1");

  line = sheet.AddUnit(NULL, "line");
  line.Execute("PointCount = 3; LinkMode = 1; Bytes[1] = 8; Bytes[2] = 8");
  sheet.SetLink(d2, line, "L3", "P0");
  sheet.SetLink(line, d3, "P1", "L1");

  line = sheet.AddUnit(NULL, "line");
  line.Execute("PointCount = 2; LinkMode = 1; Bytes[1] = 8");
  sheet.SetLink(d2, line, "L2", "P0");
  line.Execute("X[2] = X[0]");
  sheet.SetLink(line, Line1, "P1", "");

  d1.Refresh();
  d2.Refresh();
  d3.Refresh();
}

void UseunitLink::OnButton2() 
{
  Cvg vg = vg1.GetVg();
  CSheet sheet = vg.GetActiveSheet();
  CGroup g = vg.GetSelection();
  int i = 0;
  int n = sheet.GetUnitCount();
  while (i < n)
  {
    CUnit d = sheet.GetUnits(i);
    int j = 0;
    while (j < d.GetLinkCount())
    {
      CUnit el = d.GetLinks(j);
      CString ft = d.GetLinkFoots(j);
      g.Clear();
      g.Add(d);
      MessageBox("Unit " + d.GetName() + " links to: " + el.GetName() + " at postion: " + ft);
      j = j + 1;
    }
    i = i + 1;
  }
}
